//+------------------------------------------------------------------+
//|                                                        Juice.mq4 |
//|                                                          Perky_z |
//|                              http://fxovereasy.atspace.com/index |
//+------------------------------------------------------------------+
#property  copyright "perky"
#property  link      "http://fxovereasy.atspace.com/index"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  LimeGreen
#property  indicator_color2  FireBrick
//---- indicator parameters
extern int JPeriod=7;


//---- indicator buffers
double OsMAUpBuffer[];
double OsMADownBuffer[];
double OsMABuffer[];
double MACDBuffer[];            
double SignalBuffer[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 2 additional buffers are used for counting.
   IndicatorBuffers(5);
//---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,2,LimeGreen);     
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,2,FireBrick);        
   SetIndexDrawBegin(0,GetLevel());
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);
//---- 3 indicator buffers mapping
   if(!SetIndexBuffer(0,OsMAUpBuffer) &&
      !SetIndexBuffer(1,OsMADownBuffer) &&
      !SetIndexBuffer(2,OsMABuffer) &&
      !SetIndexBuffer(3,MACDBuffer) &&
      !SetIndexBuffer(4,SignalBuffer))
      Print("cannot set indicator buffers!");
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("JuiceSpec("+JPeriod+","+GetLevel()+")");
//---- initialization done
   return(0);
  }
  
double GetLevel()
{
   if (Symbol() == "EURJPY")
  {
    if (Period() == PERIOD_M15) return(800);
    if (Period() == PERIOD_M30) return(800);
    if (Period() == PERIOD_H1) return (1100);
    return(-1);
  }
   if (Symbol() == "EURUSD")
  {
    if (Period() == PERIOD_M15) return(700);
    if (Period() == PERIOD_M30) return(700);
    if (Period() == PERIOD_H1) return (800);
    return(-1);
  } 
   if (Symbol() == "USDJPY")
  {
    if (Period() == PERIOD_M15) return(700);
    if (Period() == PERIOD_M30) return(700);
    if (Period() == PERIOD_H1) return (800);
    return(-1);
  }
   if (Symbol() == "USDCHF")
  {
    if (Period() == PERIOD_M15) return(800);
    if (Period() == PERIOD_M30) return(800);
    if (Period() == PERIOD_H1) return (800);
    return(-1);
  } 
   if (Symbol() == "GBPUSD")
  {
    if (Period() == PERIOD_M15) return(800);
    if (Period() == PERIOD_M30) return(800);
    if (Period() == PERIOD_H1) return (900);
    return(-1);
  }
 return(-1);
}
//+------------------------------------------------------------------+
//| Moving Average of Oscillator                                     |
//+------------------------------------------------------------------+
int start()
{
//if ( Period != 15)  Alert ("Juice Is Recommended for 15 Min Chart only!!");
double level;
 
  
  if (StringSubstr(Symbol(),3,3)=="JPY")
      {
      level=GetLevel()/10000;
      }
      else
      {
      level=GetLevel()/1000000;
      }
   int limit,i;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
if (level== 0.0004 && Period()==5 ) level=0.0002;

 
//---- main loop
   for(i=0; i<limit; i++){
      OsMABuffer[i]=iStdDev  (NULL,0,JPeriod,MODE_EMA,0,PRICE_CLOSE,i)-(level);
      
      if(OsMABuffer[i]>0){
         OsMAUpBuffer[i]=OsMABuffer[i];
         OsMADownBuffer[i]=0;
      }else if(OsMABuffer[i]<0){
         OsMADownBuffer[i]=OsMABuffer[i];
         OsMAUpBuffer[i]=0;
      }else{
         OsMAUpBuffer[i]=0;
         OsMADownBuffer[i]=0;
      }
   }
//---- done
   return(0);
  }
//+------------------------------------------------------------------+

